#include "classes.h"

CDate::CDate() {

	m_iYear = 0;
	m_iMonth = 0;
	m_iDay = 0;

}

CDate::CDate(const CDate & dtSrc) {

	assign(&dtSrc);

}

bool CDate::assign(const CDate *lpdtSrc) {

	if (lpdtSrc == NULL) {
		return false;
	}

	return setYear(lpdtSrc->getYear()) && setMonth(lpdtSrc->getMonth()) && setDay(lpdtSrc->getDay());

}

int CDate::getYear() const { return m_iYear; }
int CDate::getMonth() const { return m_iMonth; }
int CDate::getDay() const { return m_iDay; }

bool CDate::setDate(int iYear, int iMonth, int iDay) {
	return setYear(iYear) && setMonth(iMonth) & setDay(iDay);
}

bool CDate::setYear(int iYear) {

	if (iYear < 0) {
		return false;
	}

	m_iYear = iYear;

	return true;

}

bool CDate::setMonth(int iMonth) {

	if (iMonth < 0) {
		return false;
	}

	m_iMonth = iMonth;

	return true;

}

bool CDate::setDay(int iDay) {

	if (iDay < 0) {
		return false;
	}

	m_iDay = iDay;

	return true;

}
