/*
    ꕪ͋@ 0.10

  2004/ 7/27 ˁ@P
*/
#include "classes.h"

LRESULT CALLBACK WndProc(HWND,UINT,WPARAM,LPARAM);

HINSTANCE g_hInstance;
HWND g_hwMain;

CDataList g_dlData;
CChartBitmap g_cbChart;

HMENU g_hmMain;
HMENU g_hmFile;
HMENU g_hmLoad, g_hmExit;

bool load(LPCTSTR lpszFilePath);

#define IDM_OPEN 1
#define IDM_EXIT 2

int WINAPI WinMain (HINSTANCE hInstance,HINSTANCE hPrevInstance,
                    PSTR szCmdLine,int iCmdShow){

	MSG  msg;
	WNDCLASS wndclass;

	g_hInstance = hInstance; /* vZX̃nhۑ */

	g_cbChart.clear(500,400, 0x00ffffff);

	wndclass.style         = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = hInstance;
	wndclass.hIcon         = LoadIcon(NULL,IDI_APPLICATION);
	wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(GRAY_BRUSH);
	wndclass.lpszMenuName  = NULL;
	wndclass.lpszClassName = "CWindow";

	RegisterClass(&wndclass);

	g_hwMain = CreateWindow("CWindow", "ꕪ͋@", WS_OVERLAPPEDWINDOW,
             CW_USEDEFAULT, CW_USEDEFAULT, 560, 480, NULL, NULL, hInstance, NULL);

	g_hmMain = CreateMenu();
	g_hmFile = CreateMenu();

	AppendMenu(g_hmFile, MF_STRING, IDM_OPEN, "Ji&Oj");
	AppendMenu(g_hmFile, MF_SEPARATOR, 0, NULL);
	AppendMenu(g_hmFile, MF_STRING, IDM_EXIT, "Ii&Xj");

	AppendMenu(g_hmMain, MF_POPUP, (UINT)g_hmFile, "t@Ci&Fj");

	SetMenu(g_hwMain, g_hmMain);

	ShowWindow(g_hwMain, iCmdShow); /* EChE\ */
	UpdateWindow(g_hwMain);        /* ĕ` */

	while (GetMessage(&msg, NULL, 0, 0)) { /* bZ[W[v */

		TranslateMessage(&msg);
		DispatchMessage(&msg);

	}

	return (int)msg.wParam ;

}

LRESULT CALLBACK WndProc(HWND hwnd,UINT iMsg,WPARAM wParam,LPARAM lParam) {

	static OPENFILENAME ofn;
	static char lpszFn[256], lpszFt[256], lpszWrk[256];
	static PCHAR lpszOpen = "J", lpszSave = "ۑ";

	HDC hdc;
	PAINTSTRUCT ps;

	switch (iMsg) {

	case WM_CREATE:

		// OPENFILENAME\̏
		ofn.lStructSize = sizeof(OPENFILENAME);
		ofn.hwndOwner = g_hwMain;
		ofn.hInstance = g_hInstance;
		ofn.lpstrFilter = "f[^t@C(*.tsv)\0*.tsv\0ׂẴt@C(*.*)\0*.*\0\0";
		ofn.lpstrCustomFilter = NULL;
		ofn.nMaxCustFilter = 0;
		ofn.nFilterIndex = 1;
		ofn.lpstrFile = lpszFn;
		ofn.nMaxFile = 255;
		ofn.lpstrFileTitle = lpszFt;
		ofn.nMaxFileTitle = 255;
		ofn.lpstrInitialDir = NULL;
		ofn.lpstrTitle = NULL;
		ofn.Flags = 0;
		ofn.nFileOffset = 0;
		ofn.nFileExtension = 0;
		ofn.lpstrDefExt = NULL;
		ofn.lCustData = 0;
		ofn.lpfnHook = NULL;
		ofn.lpTemplateName = NULL;

		return 0;

	case WM_COMMAND:

		switch (LOWORD(wParam)) {

		case IDM_OPEN: // Jj[

			// _CAOݒ
			ofn.lpstrTitle=lpszOpen;
			ofn.Flags=OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
			ofn.nFilterIndex=1;

			if (!GetOpenFileName(&ofn)) { // t@CI
				return 0;
			}

			load(lpszFn);

			break;

		case IDM_EXIT:

			DestroyWindow(g_hwMain);

			break;

		}

		return 0;

	case WM_PAINT:

		hdc=BeginPaint(hwnd,&ps);

		g_cbChart.draw(hdc, 0,0);
		EndPaint(hwnd, &ps);

		return 0;

	case WM_DESTROY :

		PostQuitMessage(0);

		return 0;

	}

	return DefWindowProc (hwnd, iMsg, wParam, lParam) ;

}

bool load(LPCTSTR lpszFilePath) {

	CDataList dlTmp;

	if (!dlTmp.load(lpszFilePath)) {
		return false;
	}

	g_cbChart.setData(&dlTmp);

	g_cbChart.drawData();

	InvalidateRect(g_hwMain, NULL, FALSE);

	return true;

}
